unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBCtrls, StdCtrls, Buttons, ExtCtrls, Grids, DBGrids, ComCtrls, ActnList,
  ImgList, Db, VolgaTbl;

type
  TForm1 = class(TForm)
    DataVendors: TDataSource;
    Vendors: TVolgaTable;
    DataParts: TDataSource;
    Parts: TVolgaTable;
    DataASource: TDataSource;
    ASource: TVolgaTable;
    DataClone: TDataSource;
    AClone: TVolgaTable;
    DataOrders: TDataSource;
    Orders: TVolgaTable;
    OrdersOrderNo: TFloatField;
    OrdersCustNo: TFloatField;
    OrdersCustomers: TStringField;
    OrdersSaleDate: TDateTimeField;
    OrdersShipDate: TDateTimeField;
    OrdersEmpNo: TIntegerField;
    OrdersPaymentMethod: TStringField;
    OrdersItemsTotal: TFloatField;
    OrdersAmountPaid: TFloatField;
    OrdersShipVIA: TStringField;
    OrdersPO: TStringField;
    OrdersTerms: TStringField;
    OrdersEmployee: TStringField;
    DataCusomers: TDataSource;
    Customers: TVolgaTable;
    Employee: TVolgaTable;
    DataBiolife: TDataSource;
    Biolife: TVolgaTable;
    ImageList1: TImageList;
    ActionList1: TActionList;
    ASave: TAction;
    AUndo: TAction;
    AFind: TAction;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label10: TLabel;
    LabelDetail: TLabel;
    DBGrid1: TDBGrid;
    DBGrid2: TDBGrid;
    DBNavigator1: TDBNavigator;
    Button1: TButton;
    Button2: TButton;
    TabSheet2: TTabSheet;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    LabelSource: TLabel;
    LabelClone: TLabel;
    Button3: TSpeedButton;
    Button4: TSpeedButton;
    Label12: TLabel;
    Label13: TLabel;
    Label18: TLabel;
    Label8: TLabel;
    LabelSum: TLabel;
    DBGrid3: TDBGrid;
    DBGrid4: TDBGrid;
    Edit2: TEdit;
    TabSheet3: TTabSheet;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    LabelFind: TLabel;
    Label9: TLabel;
    LabelField: TLabel;
    DBGrid6: TDBGrid;
    Button5: TButton;
    DBGrid7: TDBGrid;
    TabSheet4: TTabSheet;
    Label14: TLabel;
    DBGrid5: TDBGrid;
    DBMemo1: TDBMemo;
    DBImage1: TDBImage;
    Edit1: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure VendorsAfterScroll(DataSet: TDataSet);
    procedure DBGrid1TitleClick(Column: TColumn);
    procedure DBGrid2TitleClick(Column: TColumn);
    procedure ASaveUpdate(Sender: TObject);
    procedure ASaveExecute(Sender: TObject);
    procedure AUndoExecute(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ASourceFilterRecord(DataSet: TDataSet; var Accept: Boolean);
    procedure ACloneFilterRecord(DataSet: TDataSet; var Accept: Boolean);
    procedure ACloneFilterRecord2(DataSet: TDataSet; var Accept: Boolean);
    procedure DBGrid3TitleClick(Column: TColumn);
    procedure DBGrid4TitleClick(Column: TColumn);
    procedure ASourceAfterPost(DataSet: TDataSet);
    procedure AFindUpdate(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure DBGrid7ColEnter(Sender: TObject);
    procedure AFindExecute(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Edit2Enter(Sender: TObject);
    procedure Edit2Exit(Sender: TObject);
    procedure PageControl1Changing(Sender: TObject;
      var AllowChange: Boolean);
    procedure ASourceAfterScroll(DataSet: TDataSet);
    procedure ACloneAfterScroll(DataSet: TDataSet);
    procedure PartsAfterScroll(DataSet: TDataSet);
  private
    //Private declarations
    Filt2: Boolean;
  public
    //Public declarations
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Filt2 := false;
  PageControl1.ActivePage := TabSheet1;
  PageControl1Change(PageControl1);
end;

procedure TForm1.VendorsAfterScroll(DataSet: TDataSet);
begin
  Parts.SetRange(Vendors.FieldByName('VendorNo').AsString,
    Vendors.FieldByName('VendorNo').AsString);
end;

procedure TForm1.DBGrid1TitleClick(Column: TColumn);
begin
  Vendors.IndexFieldNames := Column.FieldName;
end;

procedure TForm1.DBGrid2TitleClick(Column: TColumn);
begin
  Parts.IndexFieldNames := Column.FieldName;
end;

procedure TForm1.ASaveUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := Vendors.NeedToSave or Parts.NeedToSave or
    (Vendors.State = dsInsert) or (Vendors.State = dsEdit) or
    (Parts.State = dsInsert) or (Parts.State = dsEdit);
end;

procedure TForm1.ASaveExecute(Sender: TObject);
begin
  Vendors.SaveToFile(Vendors.FileName);
  Vendors.ApplyUpdates;
  Parts.SaveToFile(Parts.FileName);
  Parts.ApplyUpdates;
end;

procedure TForm1.AUndoExecute(Sender: TObject);
begin
  Vendors.CancelUpdates;
  Parts.CancelUpdates;
end;

procedure TForm1.PageControl1Change(Sender: TObject);
begin
  Parts.Active := (PageControl1.ActivePage = TabSheet1);
  Vendors.Active := (PageControl1.ActivePage = TabSheet1);
  ASource.Active := (PageControl1.ActivePage = TabSheet2);
  AClone.Active := (PageControl1.ActivePage = TabSheet2);
  Customers.Active := (PageControl1.ActivePage = TabSheet3);
  Employee.Active := (PageControl1.ActivePage = TabSheet3);
  Orders.Active := (PageControl1.ActivePage = TabSheet3);
  Biolife.Active := (PageControl1.ActivePage = TabSheet4);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  ASource.Filtered := Button3.Down;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  if Filt2 then
    Edit2Exit(Edit2);
  AClone.Filtered := Button4.Down;
end;

procedure TForm1.ASourceFilterRecord(DataSet: TDataSet;
  var Accept: Boolean);
begin
  Accept := DataSet.FieldByName('Area').AsFloat > 1000000;
end;

procedure TForm1.ACloneFilterRecord(DataSet: TDataSet;
  var Accept: Boolean);
begin
  Accept := DataSet.FieldByName('Continent').AsString = 'North America';
end;

procedure TForm1.ACloneFilterRecord2(DataSet: TDataSet;
  var Accept: Boolean);
begin
  Accept := Pos(Edit2.Text, DataSet.FieldByName('Name').AsString) > 0;
end;

procedure TForm1.DBGrid3TitleClick(Column: TColumn);
begin
  ASource.IndexFieldNames := Column.FieldName;
end;

procedure TForm1.DBGrid4TitleClick(Column: TColumn);
begin
  AClone.IndexFieldNames := Column.FieldName;
end;

procedure TForm1.ASourceAfterPost(DataSet: TDataSet);
begin
  AClone.Refresh;
end;

procedure TForm1.AFindUpdate(Sender: TObject);
begin
  AFind.Enabled := (PageControl1.ActivePage = TabSheet3) and
    (Edit1.Text > '') and (DBGrid7.SelectedField <> nil);
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  AFind.Caption := 'Find first';
  LabelFind.Visible := false;
end;

procedure TForm1.DBGrid7ColEnter(Sender: TObject);
begin
  LabelField.Caption := DBGrid7.SelectedField.FieldName;
end;

procedure TForm1.AFindExecute(Sender: TObject);
var f: Boolean;
begin
  f := Customers.Like(DBGrid7.SelectedField.FieldName, Edit1.Text, false,
    (AFind.Caption = 'Find first'));
  if f then
    AFind.Caption := 'Find next'
  else
    LabelFind.Visible := true;
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
  AClone.Filtered := (Edit2.Text > '');
end;

procedure TForm1.Edit2Enter(Sender: TObject);
begin
  AClone.Filtered := false;
  Button4.Down := false;
  AClone.OnFilterRecord := ACloneFilterRecord2;
  Filt2 := true;
end;

procedure TForm1.Edit2Exit(Sender: TObject);
begin
  AClone.Filtered := false;
  AClone.OnFilterRecord := ACloneFilterRecord;
  Filt2 := false;
end;

procedure TForm1.PageControl1Changing(Sender: TObject;
  var AllowChange: Boolean);
begin
  if PageControl1.ActivePage = TabSheet2 then
  begin
    ASource.Filtered := false;
    Button3.Down := false;
    AClone.Filtered := false;
    Button4.Down := false;
  end;
end;

procedure TForm1.ASourceAfterScroll(DataSet: TDataSet);
begin
  LabelSource.Caption := 'Source - ' + IntToStr(ASource.RecordCount) + ' records';
end;

procedure TForm1.ACloneAfterScroll(DataSet: TDataSet);
begin
  LabelClone.Caption := 'Clone - ' + IntToStr(AClone.RecordCount) + ' records';
  LabelSum.Caption := FormatFloat('### ### ##0.##', AClone.GetSum('Area'));
end;

procedure TForm1.PartsAfterScroll(DataSet: TDataSet);
begin
  LabelDetail.Caption := 'Detail - ' + IntToStr(Parts.RecordCount) + ' records';
end;

end.

